using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections.Specialized;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Drawing;
using Syncfusion.Styles;
using Syncfusion.Windows.Forms;

namespace GGC_Sample2005
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    #region // DataSource

    private DataTable GetTable()
    {
      DataTable dt = new DataTable("MyTable");

      int nCols = 5;
      int nRows = 10;

      for (int i = 0; i < nCols; i++)
      {
          dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
      }
      //dt.Columns.Add(new DataColumn("Enum Column", typeof(MyEnum)));
      for (int i = 0; i < nRows; ++i)
      {
        DataRow dr = dt.NewRow();
        for (int j = 0; j < nCols; j++)
        {
                dr[j] = string.Format("row{0} col{1}", i, j);
        }
        //dr[nCols] = MyEnum.ValueA;
        dt.Rows.Add(dr);
      }
      return dt;
    }

    #endregion

      private void Form1_Load(object sender, EventArgs e)
    {

          // Setting style and options
        this.gridGroupingControl1.TableOptions.GridLineBorder = new Syncfusion.Windows.Forms.Grid.GridBorder(GridBorderStyle.Solid, Color.Silver, GridBorderWeight.Thin);

        this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);

        this.gridGroupingControl1.TableControlCellClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);

        this.gridGroupingControl1.TableControlDrawCell += new GridTableControlDrawCellEventHandler(gridGroupingControl1_TableControlDrawCell);

        GridTableCellStyleInfo info = gridGroupingControl1.TableDescriptor.Appearance.AddNewRecordFieldCell;
        info.CellType = "Static";
    }

      
        void gridGroupingControl1_TableControlDrawCell(object sender, GridTableControlDrawCellEventArgs e)
        {
            GridTableCellStyleInfo styleInfo = (GridTableCellStyleInfo)e.Inner.Style;
            if (styleInfo.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.AddNewRecord
                && e.Inner.ColIndex > 0 )
            {
                e.Inner.Renderer.Draw(e.Inner.Graphics, e.Inner.Bounds, e.Inner.RowIndex, e.Inner.ColIndex, e.Inner.Style);
                e.Inner.Graphics.DrawString("Click Here to add a new record", new Font("Arial", 10f), Brushes.Blue, e.Inner.Bounds);
                e.Inner.Cancel = true;
            }
        }

    void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
    {
      GridTableCellStyleInfo styleInfo = (GridTableCellStyleInfo)e.TableControl.GetTableViewStyleInfo(e.Inner.RowIndex, e.Inner.ColIndex);
      if (styleInfo.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.AddNewRecord)
      {
        // open the dialog to you want to show here
        if (MessageBox.Show("Open some dialog you want to show here", "Show Dialog", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
        {
          ColorDialog dlg = new ColorDialog();
          dlg.ShowDialog();
        }
      }
    }

    void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
    {
        if (e.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.AddNewRecord && e.TableCellIdentity.ColIndex > 0)
        {
            e.Style.BackColor = Color.AliceBlue;
           
            e.Style.HorizontalAlignment = GridHorizontalAlignment.Center;
            e.Style.CellType = "Static";
        }
    }

      private void button1_Click(object sender, EventArgs e)
      {
          BindingList<MyObject> table = new BindingList<MyObject>();
          table.Add(new MyObject());

          this.gridGroupingControl1.DataSource = table;

          foreach (Element el in this.gridGroupingControl1.Table.DisplayElements)
          {
              if (el.Kind == DisplayElementKind.AddNewRecord)
              {
                  GridRangeInfo range = this.gridGroupingControl1.Table.GetElementRangeInfo(el);
                  int count = this.gridGroupingControl1.TableDescriptor.VisibleColumns.Count;
                  this.gridGroupingControl1.TableModel.CoveredRanges.Add(GridRangeInfo.Cells(range.Top, 1, range.Bottom, count));
                  break;
              }
          }
      }
   
  }

}